<script>$INDEX=0</script>
<script title="questionbank">
var questionbank =[
    {
        "Q": "Why did the chicken cross the road ?",
        "A": "Too hard to fly"
    },
    {
        "Q": "Why did the chicken cross the road the second time ?",
        "A": "Fly not !"
    }
    
]

</script>
<script>
    (async() => {
        function csvJSON(csv) {
            const lines = csv.split('\r\n')
            const result = []
            const headers = lines[0].split(',')

            for (let i = 1; i < lines.length; i++) {        
                if (!lines[i])
                    continue
                const obj = {}
                const currentline = lines[i].split(',')

                for (let j = 0; j < headers.length; j++) {
                    obj[headers[j]] = currentline[j]
                }
                result.push(obj)
            }
            return result
        }
        
        const urlParams = new URLSearchParams(window.location.search);
        // workaround --> add "&output=csv". it gets split as a separate query param
        const myparam = urlParams.get('csv')+"&output=csv";
        console.log(myparam)
        var res = await fetch(myparam);
        var body = await res.text()
        var json = csvJSON(body);
        if(json.length <= 0){
            console.log("could not load url --> %o", myparam)
        }
        document.getElementById('top').innerHTML = `Could not load <a href=${myparam}>questions</a>`;
        console.log(json)
        questionbank = json;
        initial();
    })()
    
</script>
<style>
    td{background-color: floralwhite;}
    .disable-dbl-tap-zoom {
      touch-action: manipulation;
    }
</style>

<script>
  let renderq = (el) => el.innerHTML = `(${$INDEX + 1 }) <em>${questionbank[$INDEX].Q}</em>`;
  let rendera = (el) => el.innerHTML = `<em>${questionbank[$INDEX].A}</em>`;
  let hidea = (el) => el.innerHTML = `<em>Tap to reveal...</em>`;
  let updateprogress = (el) => { var progress = new Array(questionbank.length).fill("."); progress[questionbank.length-1]=questionbank.length-1; progress[$INDEX] = `${$INDEX+1}`; el.innerHTML = progress.join("");}
  let incrementindex = (count) => $INDEX = $INDEX + count >= questionbank.length? questionbank.length - 1 : $INDEX + count;
  let decrementindex = (count) => $INDEX = $INDEX - count <= 0 ? 0 : $INDEX - count;
  let initial = () => {updateprogress(document.getElementById('progress')); renderq(document.getElementById('top'));};
  let next  = () => {incrementindex(1); updateprogress(document.getElementById('progress')); renderq(document.getElementById('top')); hidea(document.getElementById('bottom'));}
  let next5 = () => {incrementindex(5); updateprogress(document.getElementById('progress')); renderq(document.getElementById('top')); hidea(document.getElementById('bottom'));}
  let prev  = () => {decrementindex(1); updateprogress(document.getElementById('progress')); renderq(document.getElementById('top')); hidea(document.getElementById('bottom'));}
  let prev5 = () => {decrementindex(5); updateprogress(document.getElementById('progress')); renderq(document.getElementById('top')); hidea(document.getElementById('bottom'));}
</script>

<table style="height: 85vh;background-color: red; width: 98vw; border-spacing: 5px; font-size: 8rem;">
  <tr>
    <!-- <td id="top">top</td> -->
    <td id="top" onclick="next();"> Loading...
      <!-- <script>
        renderq(document.currentScript.parentElement);
      </script> -->
    </td>
  </tr>
  <tr style="height: 10%;">
    <td>
      <table>
        <tr>
          <td><button class="disable-dbl-tap-zoom" style="font-size: 3.4rem;" onclick="prev5()"><<</button></td>
          <td><button class="disable-dbl-tap-zoom" style="font-size: 3.4rem;" onclick="prev()"><</button></td>
          <td><button class="disable-dbl-tap-zoom" style="font-size: 3.4rem;">N</button></td>
          <td><button class="disable-dbl-tap-zoom" style="font-size: 3.4rem;">Y</button></td>
          <td><button class="disable-dbl-tap-zoom" style="font-size: 3.4rem;" onclick="next()">></button></td>
          <td><button class="disable-dbl-tap-zoom" style="font-size: 3.4rem;" onclick="next5()">>></button></td>
        </tr>
        <tr style="width: 98vw; word-break: break-word;">
            <td colspan="6" id="progress" style="font-size: 2rem;"></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <!-- <td onclick="this.innerText=123">bottom</td> -->
    <td id="bottom" onclick="rendera(this)">
      <em>Tap to reveal...</em>
    </td>
  </tr>
</table>
